
_interrupt:

;RaceLights.c,37 :: 		void interrupt(void) {
;RaceLights.c,38 :: 		TMR0H = 0x48;    // preset for Timer0 MSB register
	MOVLW       72
	MOVWF       TMR0H+0 
;RaceLights.c,39 :: 		TMR0L = 0xE5;    // preset for Timer0 LSB register
	MOVLW       229
	MOVWF       TMR0L+0 
;RaceLights.c,40 :: 		TMR0IF_bit = 0;
	BCF         TMR0IF_bit+0, 2 
;RaceLights.c,42 :: 		if ( blnRunning == TRUE && blnTimerExpired == FALSE ) {
	MOVF        RaceLights_blnRunning+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_interrupt2
	MOVF        RaceLights_blnTimerExpired+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_interrupt2
L__interrupt27:
;RaceLights.c,43 :: 		blnTimerExpired = TRUE;
	MOVLW       1
	MOVWF       RaceLights_blnTimerExpired+0 
;RaceLights.c,44 :: 		}
L_interrupt2:
;RaceLights.c,45 :: 		}
L_end_interrupt:
L__interrupt31:
	RETFIE      1
; end of _interrupt

_resetLights:

;RaceLights.c,49 :: 		void resetLights(void) {
;RaceLights.c,51 :: 		blnRunning = blnTimerExpired = FALSE;
	CLRF        RaceLights_blnTimerExpired+0 
	MOVF        RaceLights_blnTimerExpired+0, 0 
	MOVWF       RaceLights_blnRunning+0 
;RaceLights.c,53 :: 		intStep = 0;
	CLRF        RaceLights_intStep+0 
	CLRF        RaceLights_intStep+1 
;RaceLights.c,55 :: 		LATB = 0;
	CLRF        LATB+0 
;RaceLights.c,56 :: 		}
L_end_resetLights:
	RETURN      0
; end of _resetLights

_main:

;RaceLights.c,60 :: 		void main(void) {
;RaceLights.c,63 :: 		ANSELA = 0;                    // Configure PORTA pins as digital
	CLRF        ANSELA+0 
;RaceLights.c,64 :: 		ANSELB = 0;                    // Configure PORTB pins as digital
	CLRF        ANSELB+0 
;RaceLights.c,69 :: 		TRISA = 0xff;                  // Configure PORTA as input
	MOVLW       255
	MOVWF       TRISA+0 
;RaceLights.c,70 :: 		TRISB = 0;                     // Configure PORTB as output
	CLRF        TRISB+0 
;RaceLights.c,71 :: 		LATB  = 0;                     // Clear PORTB
	CLRF        LATB+0 
;RaceLights.c,73 :: 		resetLights();
	CALL        _resetLights+0, 0
;RaceLights.c,77 :: 		T0CON.TMR0ON = 1;// On/Off Control bit, 1=Enable, 0=Disable
	BSF         T0CON+0, 7 
;RaceLights.c,78 :: 		T0CON.T08BIT = 0;// 8-bit/16-bit Control bi: 0=16-bit timer/counter
	BCF         T0CON+0, 6 
;RaceLights.c,79 :: 		T0CON.T0CS   = 0;// Clock Source Select bit: 0=Internal Clock (CLKO)
	BCF         T0CON+0, 5 
;RaceLights.c,80 :: 		T0CON.T0SE   = 0;// Source Edge Select bit: 0=low/high
	BCF         T0CON+0, 4 
;RaceLights.c,81 :: 		T0CON.PSA    = 0;// Prescaler Assignment bit: 0=Prescaler is assigned; 1=NOT assigned/bypassed
	BCF         T0CON+0, 3 
;RaceLights.c,82 :: 		T0CON.T0PS2  = 1;// bits 2-0  PS2:PS0: Prescaler Select bits
	BSF         T0CON+0, 2 
;RaceLights.c,83 :: 		T0CON.T0PS1  = 0;
	BCF         T0CON+0, 1 
;RaceLights.c,84 :: 		T0CON.T0PS0  = 0;
	BCF         T0CON+0, 0 
;RaceLights.c,85 :: 		TMR0H = 0x48;    // preset for Timer0 MSB register
	MOVLW       72
	MOVWF       TMR0H+0 
;RaceLights.c,86 :: 		TMR0L = 0xE5;    // preset for Timer0 LSB register
	MOVLW       229
	MOVWF       TMR0L+0 
;RaceLights.c,87 :: 		TMR0IE_bit = 1;
	BSF         TMR0IE_bit+0, 5 
;RaceLights.c,89 :: 		GIE_bit = 1;
	BSF         GIE_bit+0, 7 
;RaceLights.c,91 :: 		while( 1 ) {
L_main3:
;RaceLights.c,92 :: 		if ( blnRunning == TRUE ) {
	MOVF        RaceLights_blnRunning+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_main5
;RaceLights.c,93 :: 		if ( Button(&PORTA, STOP_BUTTON, BUTTON_DEBOUNCE, 1) ) {
	MOVLW       PORTA+0
	MOVWF       FARG_Button_port+0 
	MOVLW       hi_addr(PORTA+0)
	MOVWF       FARG_Button_port+1 
	MOVLW       1
	MOVWF       FARG_Button_pin+0 
	MOVLW       20
	MOVWF       FARG_Button_time_ms+0 
	MOVLW       1
	MOVWF       FARG_Button_active_state+0 
	CALL        _Button+0, 0
	MOVF        R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_main6
;RaceLights.c,94 :: 		blnRunning = FALSE;
	CLRF        RaceLights_blnRunning+0 
;RaceLights.c,95 :: 		LATB |= PAUSED;
	BSF         LATB+0, 6 
;RaceLights.c,96 :: 		} else if ( blnTimerExpired == TRUE ) {
	GOTO        L_main7
L_main6:
	MOVF        RaceLights_blnTimerExpired+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_main8
;RaceLights.c,97 :: 		switch( intStep ) {
	GOTO        L_main9
;RaceLights.c,98 :: 		case 0:         // Light 1
L_main11:
;RaceLights.c,99 :: 		LATB |= LIGHT_1;
	BSF         LATB+0, 0 
;RaceLights.c,100 :: 		break;
	GOTO        L_main10
;RaceLights.c,101 :: 		case 1:         // Light 2
L_main12:
;RaceLights.c,102 :: 		LATB |= LIGHT_2;
	BSF         LATB+0, 1 
;RaceLights.c,103 :: 		break;
	GOTO        L_main10
;RaceLights.c,104 :: 		case 2:         // Light 3
L_main13:
;RaceLights.c,105 :: 		LATB |= LIGHT_3;
	BSF         LATB+0, 2 
;RaceLights.c,106 :: 		break;
	GOTO        L_main10
;RaceLights.c,107 :: 		case 3:         // Light 4
L_main14:
;RaceLights.c,108 :: 		LATB |= LIGHT_4;
	BSF         LATB+0, 3 
;RaceLights.c,109 :: 		break;
	GOTO        L_main10
;RaceLights.c,110 :: 		case 4:         // Light 5
L_main15:
;RaceLights.c,111 :: 		LATB |= LIGHT_5;
	BSF         LATB+0, 4 
;RaceLights.c,113 :: 		intOutCount = rand() % (7 - 3) + 3;
	CALL        _rand+0, 0
	MOVLW       4
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Div_16x16_S+0, 0
	MOVF        R8, 0 
	MOVWF       R0 
	MOVF        R9, 0 
	MOVWF       R1 
	MOVLW       3
	ADDWF       R0, 0 
	MOVWF       RaceLights_intOutCount+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       RaceLights_intOutCount+1 
;RaceLights.c,114 :: 		break;
	GOTO        L_main10
;RaceLights.c,115 :: 		case 5:         // All out race starts
L_main16:
;RaceLights.c,116 :: 		if ( --intOutCount == 0 ) {
	MOVLW       1
	SUBWF       RaceLights_intOutCount+0, 1 
	MOVLW       0
	SUBWFB      RaceLights_intOutCount+1, 1 
	MOVLW       0
	XORWF       RaceLights_intOutCount+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main34
	MOVLW       0
	XORWF       RaceLights_intOutCount+0, 0 
L__main34:
	BTFSS       STATUS+0, 2 
	GOTO        L_main17
;RaceLights.c,117 :: 		resetLights();
	CALL        _resetLights+0, 0
;RaceLights.c,118 :: 		LATB |= GO_GO_GO;
	BSF         LATB+0, 5 
;RaceLights.c,119 :: 		}
L_main17:
;RaceLights.c,120 :: 		break;
	GOTO        L_main10
;RaceLights.c,121 :: 		}
L_main9:
	MOVLW       0
	XORWF       RaceLights_intStep+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main35
	MOVLW       0
	XORWF       RaceLights_intStep+0, 0 
L__main35:
	BTFSC       STATUS+0, 2 
	GOTO        L_main11
	MOVLW       0
	XORWF       RaceLights_intStep+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main36
	MOVLW       1
	XORWF       RaceLights_intStep+0, 0 
L__main36:
	BTFSC       STATUS+0, 2 
	GOTO        L_main12
	MOVLW       0
	XORWF       RaceLights_intStep+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main37
	MOVLW       2
	XORWF       RaceLights_intStep+0, 0 
L__main37:
	BTFSC       STATUS+0, 2 
	GOTO        L_main13
	MOVLW       0
	XORWF       RaceLights_intStep+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main38
	MOVLW       3
	XORWF       RaceLights_intStep+0, 0 
L__main38:
	BTFSC       STATUS+0, 2 
	GOTO        L_main14
	MOVLW       0
	XORWF       RaceLights_intStep+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main39
	MOVLW       4
	XORWF       RaceLights_intStep+0, 0 
L__main39:
	BTFSC       STATUS+0, 2 
	GOTO        L_main15
	MOVLW       0
	XORWF       RaceLights_intStep+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main40
	MOVLW       5
	XORWF       RaceLights_intStep+0, 0 
L__main40:
	BTFSC       STATUS+0, 2 
	GOTO        L_main16
L_main10:
;RaceLights.c,122 :: 		if ( (LATB & GO_GO_GO) != GO_GO_GO && intStep < 5 ) {
	MOVLW       32
	ANDWF       LATB+0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	XORLW       32
	BTFSC       STATUS+0, 2 
	GOTO        L_main20
	MOVLW       128
	XORWF       RaceLights_intStep+1, 0 
	MOVWF       R0 
	MOVLW       128
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main41
	MOVLW       5
	SUBWF       RaceLights_intStep+0, 0 
L__main41:
	BTFSC       STATUS+0, 0 
	GOTO        L_main20
L__main29:
;RaceLights.c,123 :: 		intStep++;
	INFSNZ      RaceLights_intStep+0, 1 
	INCF        RaceLights_intStep+1, 1 
;RaceLights.c,124 :: 		}
L_main20:
;RaceLights.c,126 :: 		blnTimerExpired = FALSE;
	CLRF        RaceLights_blnTimerExpired+0 
;RaceLights.c,127 :: 		}
L_main8:
L_main7:
;RaceLights.c,128 :: 		} else if ( (LATB & GO_GO_GO) != GO_GO_GO &&
	GOTO        L_main21
L_main5:
	MOVLW       32
	ANDWF       LATB+0, 0 
	MOVWF       R1 
;RaceLights.c,129 :: 		Button(&PORTA, START_BUTTON, BUTTON_DEBOUNCE, 1) ) {
	MOVF        R1, 0 
	XORLW       32
	BTFSC       STATUS+0, 2 
	GOTO        L_main24
	MOVLW       PORTA+0
	MOVWF       FARG_Button_port+0 
	MOVLW       hi_addr(PORTA+0)
	MOVWF       FARG_Button_port+1 
	CLRF        FARG_Button_pin+0 
	MOVLW       20
	MOVWF       FARG_Button_time_ms+0 
	MOVLW       1
	MOVWF       FARG_Button_active_state+0 
	CALL        _Button+0, 0
	MOVF        R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_main24
L__main28:
;RaceLights.c,130 :: 		blnRunning = TRUE;
	MOVLW       1
	MOVWF       RaceLights_blnRunning+0 
;RaceLights.c,131 :: 		} else if ( Button(&PORTA, RESET_BUTTON, BUTTON_DEBOUNCE, 1) ) {
	GOTO        L_main25
L_main24:
	MOVLW       PORTA+0
	MOVWF       FARG_Button_port+0 
	MOVLW       hi_addr(PORTA+0)
	MOVWF       FARG_Button_port+1 
	MOVLW       2
	MOVWF       FARG_Button_pin+0 
	MOVLW       20
	MOVWF       FARG_Button_time_ms+0 
	MOVLW       1
	MOVWF       FARG_Button_active_state+0 
	CALL        _Button+0, 0
	MOVF        R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_main26
;RaceLights.c,132 :: 		resetLights();
	CALL        _resetLights+0, 0
;RaceLights.c,133 :: 		}
L_main26:
L_main25:
L_main21:
;RaceLights.c,134 :: 		}
	GOTO        L_main3
;RaceLights.c,135 :: 		}
L_end_main:
	GOTO        $+0
; end of _main
